diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
index f98e5308b..b5aef22a4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
@@ -9,11 +9,11 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLever;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.useless.dragonfly.DisplayPos;
+import org.joml.Vector3d;
+import org.joml.primitives.AABBd;
 
 public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelLever(Block<T> block) {
@@ -21,193 +21,165 @@ public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int l = worldSource.getBlockMetadata(x, y, z);
-        int i1 = l & 15;
-        boolean flag = (l & 16) > 0;
-        boolean flag1 = renderBlocks.overrideBlockTexture != null;
-        if(!flag1)
-        {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int data = worldSource.getBlockData(tilePos);
+        int rotation = data & BlockLogicLever.MASK_ROTATION;
+        boolean powered = (data & BlockLogicLever.MASK_POWERED) != 0;
+        boolean overrideTexture = renderBlocks.overrideBlockTexture != null;
+        if (!overrideTexture) {
             renderBlocks.overrideBlockTexture = TextureRegistry.getTexture("minecraft:block/cobbled_stone");
         }
         float f = 0.25F;
         float f1 = 0.1875F;
         float f2 = 0.1875F;
-        AABB bounds = block.getBounds();
-        switch (i1) {
+        AABBd bounds = new AABBd(this.block.getBounds());
+        switch (rotation) {
             case BlockLogicLever.ROTATION_BOTTOM_NS:
-                bounds.set(0.5F - f1, 1f - f2, 0.5F - f, 0.5F + f1, 1f, 0.5F + f);
+                bounds.setMin(0.5F - f1, 1f - f2, 0.5F - f).setMax(0.5F + f1, 1f, 0.5F + f);
                 break;
             case BlockLogicLever.ROTATION_BOTTOM_WE:
-                bounds.set(0.5F - f, 1f - f2, 0.5F - f1, 0.5F + f, 1f, 0.5F + f1);
+                bounds.setMin(0.5F - f, 1f - f2, 0.5F - f1).setMax(0.5F + f, 1f, 0.5F + f1);
                 break;
             case BlockLogicLever.ROTATION_TOP_NS:
-                bounds.set(0.5F - f1, 0.0F, 0.5F - f, 0.5F + f1, f2, 0.5F + f);
+                bounds.setMin(0.5F - f1, 0.0F, 0.5F - f).setMax(0.5F + f1, f2, 0.5F + f);
                 break;
             case BlockLogicLever.ROTATION_TOP_WE:
-                bounds.set(0.5F - f, 0.0F, 0.5F - f1, 0.5F + f, f2, 0.5F + f1);
+                bounds.setMin(0.5F - f, 0.0F, 0.5F - f1).setMax(0.5F + f, f2, 0.5F + f1);
                 break;
             case BlockLogicLever.ROTATION_NORTH:
-                bounds.set(0.5F - f1, 0.5F - f, 1.0F - f2, 0.5F + f1, 0.5F + f, 1.0F);
+                bounds.setMin(0.5F - f1, 0.5F - f, 1.0F - f2).setMax(0.5F + f1, 0.5F + f, 1.0F);
                 break;
             case BlockLogicLever.ROTATION_SOUTH:
-                bounds.set(0.5F - f1, 0.5F - f, 0.0F, 0.5F + f1, 0.5F + f, f2);
+                bounds.setMin(0.5F - f1, 0.5F - f, 0.0F).setMax(0.5F + f1, 0.5F + f, f2);
                 break;
             case BlockLogicLever.ROTATION_WEST:
-                bounds.set(1.0F - f2, 0.5F - f, 0.5F - f1, 1.0F, 0.5F + f, 0.5F + f1);
+                bounds.setMin(1.0F - f2, 0.5F - f, 0.5F - f1).setMax(1.0F, 0.5F + f, 0.5F + f1);
                 break;
             case BlockLogicLever.ROTATION_EAST:
-                bounds.set(0.0F, 0.5F - f, 0.5F - f1, f2, 0.5F + f, 0.5F + f1);
+                bounds.setMin(0.0F, 0.5F - f, 0.5F - f1).setMax(f2, 0.5F + f, 0.5F + f1);
                 break;
         }
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-        if(!flag1)
-        {
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        if (!overrideTexture) {
             renderBlocks.overrideBlockTexture = null;
         }
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-        }else {
-			if(block.emission > 0) {
-				brightness = 1.0f;
-			}else {
-				brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
-			}
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
+        } else {
+            if (this.block.emission <= 0) {
+                brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
+            }
         }
-        
+
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
-        IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, l);
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+        IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, data);
+        if (renderBlocks.overrideBlockTexture != null) {
             texture = renderBlocks.overrideBlockTexture;
         }
         double f4 = texture.getIconUMin();
         double f5 = texture.getIconUMax();
         double f6 = texture.getIconVMin();
         double f7 = texture.getIconVMax();
-        Vec3[] avec3 = new Vec3[8];
+        Vector3d[] renderVecs = new Vector3d[8];
         float f8 = 0.0625F;
         float f9 = 0.0625F;
         float f10 = 0.625F;
-        avec3[0] = Vec3.fromPool(-f8, 0.0D, -f9);
-        avec3[1] = Vec3.fromPool(f8, 0.0D, -f9);
-        avec3[2] = Vec3.fromPool(f8, 0.0D, f9);
-        avec3[3] = Vec3.fromPool(-f8, 0.0D, f9);
-        avec3[4] = Vec3.fromPool(-f8, f10, -f9);
-        avec3[5] = Vec3.fromPool(f8, f10, -f9);
-        avec3[6] = Vec3.fromPool(f8, f10, f9);
-        avec3[7] = Vec3.fromPool(-f8, f10, f9);
-        for(int i2 = 0; i2 < 8; i2++)
-        {
-            if(flag)
-            {
-                avec3[i2].z -= 0.0625D;
-                avec3[i2].rotateAroundX(0.6981317F);
-            } else
-            {
-                avec3[i2].z += 0.0625D;
-                avec3[i2].rotateAroundX(-0.6981317F);
+        renderVecs[0] = new Vector3d(-f8, 0.0D, -f9);
+        renderVecs[1] = new Vector3d(f8, 0.0D, -f9);
+        renderVecs[2] = new Vector3d(f8, 0.0D, f9);
+        renderVecs[3] = new Vector3d(-f8, 0.0D, f9);
+        renderVecs[4] = new Vector3d(-f8, f10, -f9);
+        renderVecs[5] = new Vector3d(f8, f10, -f9);
+        renderVecs[6] = new Vector3d(f8, f10, f9);
+        renderVecs[7] = new Vector3d(-f8, f10, f9);
+        for (int i2 = 0; i2 < 8; i2++) {
+            if (powered) {
+                renderVecs[i2].z -= 0.0625D;
+                renderVecs[i2].rotateX(0.6981317F);
+            } else {
+                renderVecs[i2].z += 0.0625D;
+                renderVecs[i2].rotateX(-0.6981317F);
             }
-            if(i1 == 6 || i1 == 8)
-            {
-                avec3[i2].rotateAroundY(MathHelper.PI/2f);
+            if (rotation == 6 || rotation == 8) {
+                renderVecs[i2].rotateY(MathHelper.PI / 2f);
             }
-            if(i1 < 5)
-            {
-                avec3[i2].y -= 0.375D;
-                avec3[i2].rotateAroundX(MathHelper.PI/2f);
-                if(i1 == 4)
-                {
-                    avec3[i2].rotateAroundY(0.0F);
+            if (rotation < 5) {
+                renderVecs[i2].y -= 0.375D;
+                renderVecs[i2].rotateX(MathHelper.PI / 2f);
+                if (rotation == 4) {
+                    renderVecs[i2].rotateY(0.0F);
                 }
-                if(i1 == 3)
-                {
-                    avec3[i2].rotateAroundY(MathHelper.PI);
+                if (rotation == 3) {
+                    renderVecs[i2].rotateY(MathHelper.PI);
                 }
-                if(i1 == 2)
-                {
-                    avec3[i2].rotateAroundY(MathHelper.PI/2f);
+                if (rotation == 2) {
+                    renderVecs[i2].rotateY(MathHelper.PI / 2f);
                 }
-                if(i1 == 1)
-                {
-                    avec3[i2].rotateAroundY(-MathHelper.PI/2f);
+                if (rotation == 1) {
+                    renderVecs[i2].rotateY(-MathHelper.PI / 2f);
                 }
-                avec3[i2].x += (double)x + 0.5D;
-                avec3[i2].y += (float)y + 0.5F;
-                avec3[i2].z += (double)z + 0.5D;
-            } else if (i1 == 5 || i1 == 6)
-            {
-                avec3[i2].x += (double)x + 0.5D;
-                avec3[i2].y += (float)y + 0.125F;
-                avec3[i2].z += (double)z + 0.5D;
+                renderVecs[i2].x += (double) tilePos.x() + 0.5D;
+                renderVecs[i2].y += (float) tilePos.y() + 0.5F;
+                renderVecs[i2].z += (double) tilePos.z() + 0.5D;
+            } else if (rotation == 5 || rotation == 6) {
+                renderVecs[i2].x += (double) tilePos.x() + 0.5D;
+                renderVecs[i2].y += (float) tilePos.y() + 0.125F;
+                renderVecs[i2].z += (double) tilePos.z() + 0.5D;
             } else {
-                avec3[i2].rotateAroundX(MathHelper.PI);
-                avec3[i2].x += (double)x + 0.5D;
-                avec3[i2].y += (float)(y + 1) - 0.125F;
-                avec3[i2].z += (double)z + 0.5D;
+                renderVecs[i2].rotateX(MathHelper.PI);
+                renderVecs[i2].x += (double) tilePos.x() + 0.5D;
+                renderVecs[i2].y += (float) (tilePos.y() + 1) - 0.125D;
+                renderVecs[i2].z += (double) tilePos.z() + 0.5D;
             }
         }
 
-        Vec3 vec3;
-        Vec3 vec31;
-        Vec3 vec32;
-        Vec3 vec3d3;
-        for(int j2 = 0; j2 < 6; j2++)
-        {
-            if(j2 == 0)
-            {
+        Vector3d vec3;
+        Vector3d vec31;
+        Vector3d vec32;
+        Vector3d vec3d3;
+        for (int j2 = 0; j2 < 6; j2++) {
+            if (j2 == 0) {
                 f4 = texture.getSubIconU(0.4375);
                 f5 = texture.getSubIconU(0.5625);
                 f6 = texture.getSubIconV(0.375);
                 f7 = texture.getSubIconV(0.5);
-            } else
-            if(j2 == 2)
-            {
+            } else if (j2 == 2) {
                 f4 = texture.getSubIconU(0.4375);
                 f5 = texture.getSubIconU(0.5625);
                 f6 = texture.getSubIconV(0.375);
                 f7 = texture.getIconVMax();
             }
-            if(j2 == 0)
-            {
-                vec3 = avec3[0];
-                vec31 = avec3[1];
-                vec32 = avec3[2];
-                vec3d3 = avec3[3];
-            } else
-            if(j2 == 1)
-            {
-                vec3 = avec3[7];
-                vec31 = avec3[6];
-                vec32 = avec3[5];
-                vec3d3 = avec3[4];
-            } else
-            if(j2 == 2)
-            {
-                vec3 = avec3[1];
-                vec31 = avec3[0];
-                vec32 = avec3[4];
-                vec3d3 = avec3[5];
-            } else
-            if(j2 == 3)
-            {
-                vec3 = avec3[2];
-                vec31 = avec3[1];
-                vec32 = avec3[5];
-                vec3d3 = avec3[6];
-            } else
-            if(j2 == 4)
-            {
-                vec3 = avec3[3];
-                vec31 = avec3[2];
-                vec32 = avec3[6];
-                vec3d3 = avec3[7];
+            if (j2 == 0) {
+                vec3 = renderVecs[0];
+                vec31 = renderVecs[1];
+                vec32 = renderVecs[2];
+                vec3d3 = renderVecs[3];
+            } else if (j2 == 1) {
+                vec3 = renderVecs[7];
+                vec31 = renderVecs[6];
+                vec32 = renderVecs[5];
+                vec3d3 = renderVecs[4];
+            } else if (j2 == 2) {
+                vec3 = renderVecs[1];
+                vec31 = renderVecs[0];
+                vec32 = renderVecs[4];
+                vec3d3 = renderVecs[5];
+            } else if (j2 == 3) {
+                vec3 = renderVecs[2];
+                vec31 = renderVecs[1];
+                vec32 = renderVecs[5];
+                vec3d3 = renderVecs[6];
+            } else if (j2 == 4) {
+                vec3 = renderVecs[3];
+                vec31 = renderVecs[2];
+                vec32 = renderVecs[6];
+                vec3d3 = renderVecs[7];
             } else {
-                vec3 = avec3[0];
-                vec31 = avec3[3];
-                vec32 = avec3[7];
-                vec3d3 = avec3[4];
+                vec3 = renderVecs[0];
+                vec31 = renderVecs[3];
+                vec32 = renderVecs[7];
+                vec3d3 = renderVecs[4];
             }
             tessellator.addVertexWithUV(vec3.x, vec3.y, vec3.z, f4, f7);
             tessellator.addVertexWithUV(vec31.x, vec31.y, vec31.z, f5, f7);
@@ -217,6 +189,7 @@ public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T>
 
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelMatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelMatcher.java
index f5da93dcc..2def7f40e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelMatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelMatcher.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.DisplayPos;
@@ -21,41 +22,41 @@ public class BlockModelMatcher<T extends BlockLogic> extends BlockModelAxisAlign
 
     public BlockModelMatcher(Block<T> block, boolean isPowered) {
         super(block);
-        frontVariants = new IconCoordinate[4];
-        frontOverlayVariants = new IconCoordinate[frontVariants.length];
-        for (int i = 0; i < frontVariants.length; i++) {
-            frontVariants[i] = TextureRegistry.getTexture("minecraft:block/matcher/front" + (isPowered ? "_active" : "") + i);
-            frontOverlayVariants[i] = TextureRegistry.getTexture("minecraft:block/matcher/front" + (isPowered ? "_active" : "") + "_overlay" + i);
+        this.frontVariants = new IconCoordinate[4];
+        this.frontOverlayVariants = new IconCoordinate[this.frontVariants.length];
+        for (int i = 0; i < this.frontVariants.length; i++) {
+            this.frontVariants[i] = TextureRegistry.getTexture("minecraft:block/matcher/front" + (isPowered ? "_active" : "") + i);
+            this.frontOverlayVariants[i] = TextureRegistry.getTexture("minecraft:block/matcher/front" + (isPowered ? "_active" : "") + "_overlay" + i);
         }
 
-        for (Map.Entry<String, DisplayPos> e : displayPosMap.entrySet()) {
-            DisplayPos p = displayPosMap.get(e.getKey());
+        for (Map.Entry<String, DisplayPos> e : this.displayPosMap.entrySet()) {
+            DisplayPos p = this.displayPosMap.get(e.getKey());
             boolean flip = e.getKey().equals(DisplayPos.FIRST_PERSON_RIGHT_HAND) || e.getKey().equals(DisplayPos.THIRD_PERSON_RIGHT_HAND) || e.getKey().equals(DisplayPos.THIRD_PERSON_LEFT_HAND);
-            displayPosMap.put(e.getKey(), new DisplayPos(p.tx, p.ty, p.tz, p.rx, p.ry + (flip ? -90 : 90), p.rz, p.sx, p.sy, p.sz));
+            this.displayPosMap.put(e.getKey(), new DisplayPos(p.tx, p.ty, p.tz, p.rx, p.ry + (flip ? -90 : 90), p.rz, p.sx, p.sy, p.sz));
         }
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
-        Side rotated = getRotatedSide(side, blockAccess.getBlockMetadata(x, y, z));
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        Side rotated = getRotatedSide(side, source.getBlockData(tilePos));
         if (rotated.getAxis() == Axis.Y) {
-            random.setSeed(getPositionalSeed(x, y, z));
-            return frontVariants[random.nextInt(frontVariants.length)];
+            this.random.setSeed(getPositionalSeed(tilePos));
+            return this.frontVariants[this.random.nextInt(this.frontVariants.length)];
         }
-        return super.getBlockTexture(blockAccess, x, y, z, side);
+        return super.getBlockTexture(source, tilePos, side);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, @NotNull Side side) {
-        Side rotated = getRotatedSide(side, blockAccess.getBlockMetadata(x, y, z));
+    public @Nullable IconCoordinate getBlockOverbrightTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        Side rotated = getRotatedSide(side, source.getBlockData(tilePos));
         if (rotated.getAxis() == Axis.Y) {
-            random.setSeed(getPositionalSeed(x, y, z));
-            return frontOverlayVariants[random.nextInt(frontVariants.length)];
+            this.random.setSeed(getPositionalSeed(tilePos));
+            return this.frontOverlayVariants[this.random.nextInt(this.frontVariants.length)];
         }
-        return super.getBlockOverbrightTexture(blockAccess, x, y, z, side);
+        return super.getBlockOverbrightTexture(source, tilePos, side);
     }
 
-    public long getPositionalSeed(int x, int y, int z) {
-        return x * 374761393 + y * 668265263 + z * 968290493;
+    public long getPositionalSeed(@NotNull TilePosc tilePos) {
+        return tilePos.x() * 374761393L + tilePos.y() * 668265263L + tilePos.z() * 968290493L;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
index f65c25dd4..476c3c5b5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
@@ -5,37 +5,40 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelOverlayLeaves<T extends BlockLogic> extends BlockModelLeaves<T> {
     protected final IconCoordinate overlayTexture;
+
     public BlockModelOverlayLeaves(Block<T> block, String leavesTex, String overlayTex) {
         super(block, leavesTex);
-        overlayTexture = TextureRegistry.getTexture(overlayTex);
+        this.overlayTexture = TextureRegistry.getTexture(overlayTex);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        super.render(tessellator, worldSource, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        super.render(tessellator, worldSource, tilePos);
 
-        renderBlocks.overrideBlockTexture = overlayTexture;
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBoundsRaw(), x, y, z, 1.0f, 1.0f, 1.0f);
+        renderBlocks.overrideBlockTexture = this.overlayTexture;
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsRaw(), tilePos, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = null;
 
         return true;
     }
+
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
-        AABB bounds = block.getBounds();
+        AABBdc bounds = this.block.getBounds();
 
-        IconCoordinate overlayCoord = overlayTexture;
+        IconCoordinate overlayCoord = this.overlayTexture;
         GL11.glColor4f(brightness, brightness, brightness, alpha);
 
         tessellator.startDrawingQuads();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
index 62b54ba2a..5b6112f5b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
@@ -9,42 +9,46 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPebbles<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate[] pebbles = {
-            TextureRegistry.getTexture("minecraft:block/pebbles/0"),
-            TextureRegistry.getTexture("minecraft:block/pebbles/1"),
-            TextureRegistry.getTexture("minecraft:block/pebbles/2")
+        TextureRegistry.getTexture("minecraft:block/pebbles/0"),
+        TextureRegistry.getTexture("minecraft:block/pebbles/1"),
+        TextureRegistry.getTexture("minecraft:block/pebbles/2")
     };
+
     public BlockModelPebbles(Block<T> block) {
         super(block);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(LightmapHelper.max(block.getLightmapCoord(worldSource, x, y, z), block.getLightmapCoord(worldSource, x, y - 1, z)));
-        }else {
-        	brightness = Math.max(renderBlocks.getBlockBrightness(worldSource, x, y, z), renderBlocks.getBlockBrightness(worldSource, x, y - 1, z));
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(LightmapHelper.max(this.block.getLightmapCoord(worldSource, tilePos), this.block.getLightmapCoord(worldSource, tilePos.down(new TilePos()))));
+        } else {
+            brightness = Math.max(renderBlocks.getBlockBrightness(worldSource, tilePos), renderBlocks.getBlockBrightness(worldSource, tilePos.down(new TilePos())));
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         renderBlocks.renderTopFace(tessellator,
-            block.getBlockBoundsFromState(worldSource, x, y, z),
-            x, y, z,
-            getBlockTextureFromSideAndMetadata(Side.TOP, worldSource.getBlockMetadata(x, y, z)));
+            this.block.getBoundsFromState(worldSource, tilePos),
+            tilePos,
+            getBlockTextureFromSideAndMetadata(Side.TOP, worldSource.getBlockData(tilePos)));
 
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
     }
+
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        return pebbles[MathHelper.clamp(data, 0, 2)];
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        return this.pebbles[MathHelper.clamp(data, 0, 2)];
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
index c9dbad2b4..ad075a78b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
@@ -6,9 +6,11 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicEdible;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModelStandard<T> {
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/side");
@@ -22,15 +24,15 @@ public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModel
         withCustomItemBounds(f, 0.0F, f, 1.0F - f, f1, 1.0F - f);
     }
 
-    public void renderSliceSide(final Tessellator tessellator, final WorldSource worldSource, final AABB bounds, final int x, final int y, final int z, final Side side, final boolean overrideTex) {
-        if(overrideTex)
+    public void renderSliceSide(final @NotNull Tessellator tessellator, final @NotNull WorldSource worldSource, final @NotNull AABBdc bounds, @NotNull TilePosc tilePos, final @NotNull Side side, final boolean overrideTex) {
+        if (overrideTex)
             renderBlocks.overrideBlockTexture = this.insideTexture;
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, side, 0);
-        if(overrideTex)
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, side, 0);
+        if (overrideTex)
             renderBlocks.overrideBlockTexture = null;
     }
 
-    private void renderSlice(final Tessellator tessellator, final WorldSource worldSource, final AABB bounds, final int x, final int y, final int z, final int sliceX, final int sliceZ) {
+    private void renderSlice(final @NotNull Tessellator tessellator, final @NotNull WorldSource worldSource, final @NotNull AABBdc bounds, @NotNull TilePosc tilePos, final int sliceX, final int sliceZ) {
 
         final double onePix = 0.0625;
         final double sliceWidth = onePix * 8;
@@ -38,7 +40,7 @@ public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModel
         final double xMin = 0.0F + (sliceWidth * sliceX);
         final double xMax = xMin + sliceWidth;
 
-        final double zMin =  0.0F + (sliceWidth * sliceZ);
+        final double zMin = 0.0F + (sliceWidth * sliceZ);
         final double zMax = zMin + sliceWidth;
         final double offsetXMin = sliceX == 0 ? onePix : 0;
         final double offsetXMax = sliceX == 1 ? onePix : 0;
@@ -47,34 +49,34 @@ public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModel
 
         final boolean insideSouth = sliceZ == 0;
         final boolean insideNorth = sliceZ == 1;
-        final boolean insideEast = sliceX == 0 ;
+        final boolean insideEast = sliceX == 0;
         final boolean insideWest = sliceX == 1;
 
-        bounds.set(xMin + offsetXMin, 0.0F, zMin + offsetZMin, xMax - offsetXMax, 0.375F, zMax - offsetZMax);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.TOP, 0);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.BOTTOM, 0);
-        renderSliceSide(tessellator, worldSource, bounds, x, y, z, Side.SOUTH, insideSouth);
-        renderSliceSide(tessellator, worldSource, bounds, x, y, z, Side.WEST, insideWest);
+        AABBdc newBounds = new AABBd(xMin + offsetXMin, 0.0F, zMin + offsetZMin, xMax - offsetXMax, 0.375F, zMax - offsetZMax);
+        renderBlocks.renderSide(tessellator, worldSource, this, newBounds, tilePos, 1, 1, 1, Side.TOP, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, newBounds, tilePos, 1, 1, 1, Side.BOTTOM, 0);
+        renderSliceSide(tessellator, worldSource, newBounds, tilePos, Side.SOUTH, insideSouth);
+        renderSliceSide(tessellator, worldSource, newBounds, tilePos, Side.WEST, insideWest);
         renderBlocks.flipTexture = true;
-        renderSliceSide(tessellator, worldSource, bounds, x, y, z, Side.NORTH, insideNorth);
-        renderSliceSide(tessellator, worldSource, bounds, x, y, z, Side.EAST, insideEast);
+        renderSliceSide(tessellator, worldSource, newBounds, tilePos, Side.NORTH, insideNorth);
+        renderSliceSide(tessellator, worldSource, newBounds, tilePos, Side.EAST, insideEast);
         renderBlocks.flipTexture = false;
     }
 
     @Override
-    public boolean render(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, final int x, final int y, final int z) {
-        final AABB bounds = this.block.getBlockBoundsFromState(worldSource, x, y, z);
+    public boolean render(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
+        final AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
 
-        final int meta = worldSource.getBlockMetadata(x, y, z);
+        final int meta = worldSource.getBlockData(tilePos);
         renderBlocks.enableAO = true;
-        renderBlocks.cache.setupCache(this.block, worldSource, x, y, z);
+        renderBlocks.cache.setupCache(this.block, worldSource, tilePos);
         int slices = 0;
-        for(int xSlice = 0; xSlice < 2; xSlice++){
-            for(int zSlice = 0; zSlice < 2; zSlice++) {
+        for (int xSlice = 0; xSlice < 2; xSlice++) {
+            for (int zSlice = 0; zSlice < 2; zSlice++) {
                 slices++;
-                if(meta >= slices)
+                if (meta >= slices)
                     continue;
-                renderSlice(tessellator, worldSource, bounds, x, y, z, xSlice, zSlice);
+                renderSlice(tessellator, worldSource, bounds, tilePos, xSlice, zSlice);
             }
         }
 
@@ -83,5 +85,4 @@ public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModel
     }
 
 
-
 }
